%define common_summary interact with virtualization capabilities
%define common_description Libvirt is a C toolkit to interact with the virtualization\
capabilities of recent versions of Linux.

%define lib_major 0

%define lib_name %mklibname virt %{lib_major}
%define develname %mklibname -d virt
%define staticdevelname %mklibname -d -s virt

# libxenstore is not versionned properly
%define _requires_exceptions devel(libxenstore.*)

Name:       libvirt
Version:    1.0.2
%define subrel 4
Release:    %mkrel 8
Summary:    Toolkit to %{common_summary}
License:    LGPLv2+
Group:      System/Kernel and hardware
Url:        http://libvirt.org/
Source0:    http://libvirt.org/sources/%{name}-%{version}.tar.gz
Source1:    %{name}-tmpfiles.conf

# (cg) Upstream patches from the v1.0.2-maint branch
# git format-patch --start-number 100 v1.0.2..v1.0.2-maint
Patch100: 0100-complete-virterror-virerror-name-change.patch
Patch101: 0101-Fix-missing-error-constants-in-libvirt-python-module.patch
Patch102: 0102-sanitytest.py-Do-not-rely-on-system-libvirt.patch
Patch103: 0103-build-Add-libcurl-dependency-to-libvirt_driver.la.patch
Patch104: 0104-tests-Don-t-build-securityselinuxlabeltest-without-q.patch
Patch105: 0105-Fix-without-libvirtd-builds.patch
Patch106: 0106-daemon-fix-leak-after-listing-all-volumes.patch
Patch107: 0107-virsh-edit-don-t-leak-XML-string-on-reedit-or-redefi.patch
Patch108: 0108-Fix-invalid-read-in-virCgroupGetValueStr.patch
Patch109: 0109-bridge-don-t-crash-on-bandwidth-unplug-with-no-bandw.patch
Patch110: 0110-Fix-TLS-tests-with-gnutls-3.patch
Patch111: 0111-Include-process-start-time-when-doing-polkit-checks.patch
Patch112: 0112-Add-support-for-using-3-arg-pkcheck-syntax-for-proce.patch
Patch113: 0113-Fix-deps-for-generating-RPC-dispatch-code.patch
Patch114: 0114-Fix-crash-in-remoteDispatchDomainMemoryStats-CVE-201.patch
Patch115: 0115-fix-regression-in-event-deregistration.patch
Patch116: 0117-use-proper-pod-for-nested-bulleted-VIRSH_DEBUG-list.patch
Patch118: 0118-Do-not-access-stale-data-in-virDomainBlockStats.patch
Patch119: 0119-Avoid-using-stale-data-in-virDomainGetBlockInfo.patch
Patch120: 0120-Fix-job-usage-in-qemuDomainBlockJobImpl.patch
Patch121: 0121-Fix-job-usage-in-qemuDomainBlockCopy.patch
Patch122: 0122-Fix-job-usage-in-virDomainGetBlockIoTune.patch
Patch123: 0123-Don-t-crash-if-a-connection-closes-early.patch
Patch124: 0124-Really-don-t-crash-if-a-connection-closes-early.patch

Patch501: libvirt-fix-capabilities-check.patch
Patch502: libvirt-xen-not-force-blktap-disk-backend.patch
Patch503: 0002-Set-udevadm-settle-timeout-to-3-seconds.patch
Patch504: 0001-qemu-check-backing-chains-even-when-cgroup-is-omitte.patch
#Patch505: 0505-Fix-virsh.pod-syntax-error.patch
Patch506: libvirt-1.0.2-CVE-2013-5651.patch

Requires:   cyrus-sasl
%ifarch %{ix86} x86_64
BuildRequires:  xen-devel >= 3.0.4
%endif
BuildRequires:  libxml2-devel
BuildRequires:  ncurses-devel
BuildRequires:  readline-devel
BuildRequires:  python-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  gnutls-devel
BuildRequires:  libsasl-devel
BuildRequires:  libpciaccess-devel
BuildRequires:  polkit-1-devel
BuildRequires:  parted-devel
BuildRequires:  libxml2-utils
BuildRequires:  nfs-utils 
BuildRequires:  libavahi-client-devel
BuildRequires:  xmlrpc-c-devel
BuildRequires:  numa-devel
BuildRequires:  qemu
BuildRequires:  gettext-devel
BuildRequires:  netcf-devel
BuildRequires:  libnl3-devel
BuildRequires:  libpcap-devel
BuildRequires:  systemtap
BuildRequires:  libyajl-devel
BuildRequires:  pkgconfig(systemd)
BuildRequires:  libssh2-devel
# (tmb) build against kernel-devel-latest
%ifarch %{arm}
%define kflavour kirkwood
%else
%define kflavour desktop
%endif
BuildRequires:  kernel-%{kflavour}-devel-latest

# add userspace tools here because the full path to each tool is hard coded into the libvirt.so* library.
BuildRequires:  dmsetup dnsmasq-base ebtables iproute2 iptables kmod lvm2 numactl open-iscsi parted polkit radvd scrub systemd

%description
%{common_description}

Virtualization of the Linux Operating System means the
ability to run multiple instances of Operating Systems concurently on
a single hardware system where the basic resources are driven by a
Linux instance. The library aim at providing long term stable C API
initially for the Xen paravirtualization but should be able to
integrate other virtualization mechanisms if needed.

%package -n %{lib_name}
Summary:    A library to %{common_summary}
Group:      System/Libraries

%description -n %{lib_name}
%{common_description}

This package contains the library needed to run programs dynamically
linked with %{name}.

%package -n %{develname}
Summary:    Development tools for programs using %{name}
Group:      Development/C
Requires:   %{lib_name} = %{version}
%ifarch %{ix86} x86_64
Requires:   xen-devel
%endif
Provides:   %{name}-devel = %{version}-%{release}
Obsoletes:  %{lib_name}-devel

%description -n %{develname}
%{common_description}

This package contains the header files and libraries needed for
developing programs using the %{name} library.

%package -n %{staticdevelname}
Summary:    Development static libraries for programs using %{name}
Group:      Development/C
Provides:   %{name}-static-devel = %{version}-%{release}
Obsoletes:  %{lib_name}-static-devel

%description -n %{staticdevelname}
%{common_description}

This package contains the static libraries needed for developing
programs using the %{name} library.

%package -n python-%{name}
Summary:    Python bindings to %{common_summary}
Group:      Development/Python

%description -n python-%{name}
%{common_description}

This package contains the python bindings for the %{name} library.

%package -n %{name}-utils
Summary:    Tools to %{common_summary}
Group:      System/Kernel and hardware
Requires:   bridge-utils
Requires:   %{lib_name} = %{version}
Requires:   polkit
Requires:   ebtables
Requires(post):  systemd >= %{systemd_required_version}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1
# fix "Cannot check dnsmasq binary dnsmasq":
Suggests:   dnsmasq
Suggests:   netcat-openbsd
Conflicts:  libvirt0 < 0.7.1-2
Conflicts:  lib64virt0 < 0.7.1-2
Provides:   %{name}-client = %{version}-%{release}

%description -n %{name}-utils
%{common_description}

This package contains tools for the %{name} library.

%prep
%setup -q
%apply_patches

%build
%configure2_5x --disable-static \
    --localstatedir=%{_var}  \
    --with-html-subdir=%{name} \
    --with-udev \
    --with-netcf \
    --without-hal \
    --with-init_script=systemd
%make

%install
%makeinstall_std SYSTEMD_UNIT_DIR=%{_unitdir}

rm -f %{buildroot}%{_initrddir}/libvirt-guests
find %{buildroot} -name '*.la' -delete

install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_tmpfilesdir}/%{name}.conf
install -d -m 0755 %{buildroot}%{_var}/lib/%{name}
%find_lang %{name}

# fix documentation
mv %{buildroot}%{_docdir}/%{name}-python-%{version} %{buildroot}%{_docdir}/python-%{name}
install -m 644 ChangeLog README TODO NEWS %{buildroot}%{_docdir}/%{name}

%check
# fhimpe: disabled for now because it fails on 100Hz kernels, such as used on bs
# http://www.mail-archive.com/libvir-list@redhat.com/msg13727.html
#make check

%post -n %{name}-utils
%_tmpfilescreate %{name}
%_post_service  libvirtd
%_post_service  libvirt-guests
%_post_service	virtlockd

%preun -n %{name}-utils
%_preun_service libvirt-guests
%_preun_service libvirtd
%_preun_service	virtlockd

%files -n %{lib_name}
%{_libdir}/%{name}.so.%{lib_major}*
%{_libdir}/%{name}-qemu.so.%{lib_major}*
%{_libdir}/%{name}-lxc.so.%{lib_major}*

%files -n %{develname}
%{_docdir}/%{name}
%exclude %{_docdir}/%{name}/ChangeLog
%exclude %{_docdir}/%{name}/README
%exclude %{_docdir}/%{name}/TODO
%exclude %{_docdir}/%{name}/NEWS
%doc %{_datadir}/gtk-doc/html/%{name}
%{_includedir}/%{name}
%{_libdir}/%{name}.so
%{_libdir}/%{name}-qemu.so
%{_libdir}/%{name}-lxc.so
%{_libexecdir}/libvirt_lxc
%{_libdir}/pkgconfig/%{name}.pc

%files -n python-%{name}
%doc %{_docdir}/python-%{name}
%{py_platsitedir}/%{name}*.py
%{py_platsitedir}/%{name}mod*.so

%files -n %{name}-utils -f %{name}.lang
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/ChangeLog
%{_docdir}/%{name}/README
%{_docdir}/%{name}/TODO
%{_docdir}/%{name}/NEWS
%{_bindir}/*
%{_mandir}/man1/virsh.1*
%{_mandir}/man1/virt-xml-validate.1*
%{_mandir}/man1/virt-pki-validate.1*
%{_mandir}/man1/virt-host-validate.1*
%{_mandir}/man8/libvirtd.8.*
%{_sbindir}/*
%{_unitdir}/libvirtd.service
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/qemu/
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/lxc/
%dir %attr(0700, root, root) %{_localstatedir}/log/libvirt/uml/
%{_libexecdir}/libvirt_parthelper
%{_libexecdir}/libvirt_iohelper
%{_libexecdir}/libvirt-guests.sh
%{_var}/lib/libvirt
%{_datadir}/polkit-1/actions/org.libvirt.unix.policy
%{_datadir}/augeas
%{_datadir}/systemtap/tapset/*.stp
%{_datadir}/%{name}
%config(noreplace) %{_sysconfdir}/libvirt
%config(noreplace) %{_sysconfdir}/sasl2/libvirt.conf
%config(noreplace) %{_sysconfdir}/sysconfig/libvirtd
%config(noreplace) %{_sysconfdir}/sysconfig/libvirt-guests
%config(noreplace) %{_sysconfdir}/sysconfig/virtlockd
%config(noreplace) %{_sysconfdir}/logrotate.d/libvirtd*
%{_prefix}/lib/sysctl.d/libvirtd.conf
%{_unitdir}/libvirt-guests.service
%{_unitdir}/virtlockd.*
%{_tmpfilesdir}/%{name}.conf
%{_libdir}/libvirt/connection-driver
%dir %{_libdir}/libvirt/lock-driver
%{_libdir}/libvirt/lock-driver/*.so


%changelog
* Mon Feb 10 2014 luigiwalser <luigiwalser> 1.0.2-8.4.mga3
+ Revision: 587854
- Apply upstream v1.0.2-maint branch fixes
  - fixes CVE-2013-6458, CVE-2014-1447, and a few other bugs
- add patch from ubuntu to fix CVE-2013-5651

  + oden <oden>
    - add libssh2 support as well.
    - fix build deps

  + colin <colin>
    - Apply upstream v1.0.2-maint branch fixes (mga#11260 CVE-2013-4311)

  + kharec <kharec>
    - add --with-netcf to enable netcf support

  + fwang <fwang>
    - add upstream patch fixing CVE-2013-1962

* Sat Mar 30 2013 tv <tv> 1.0.2-7.mga3
+ Revision: 406773
- add patches from FC (fix creating a VM with xen)
- suggests dnsmasq instead of dnsmasq-base
  (fix "Cannot check dnsmasq binary dnsmasq")

* Sun Mar 24 2013 colin <colin> 1.0.2-6.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Sun Mar 10 2013 alien <alien> 1.0.2-5.mga3
+ Revision: 402029
- fix connection loss issue

* Fri Mar 08 2013 alien <alien> 1.0.2-4.mga3
+ Revision: 401739
- XEN: do not force blktap as disk backend

* Wed Feb 06 2013 rtp <rtp> 1.0.2-3.mga3
+ Revision: 394827
- backport upstream fix for the python binding

* Tue Feb 05 2013 rtp <rtp> 1.0.2-2.mga3
+ Revision: 394735
- fix qemu commandline when probing capabilities

* Wed Jan 30 2013 guillomovitch <guillomovitch> 1.0.2-1.mga3
+ Revision: 393598
- new version

  + tmb <tmb>
    - fix inclusion order in P4

* Mon Jan 14 2013 tmb <tmb> 1.0.1-6.mga3
+ Revision: 388067
- work around broken kernel headers (if_bridge.h not selfcontainted) (P4, upstream)

  + colin <colin>
    - Use kernel-source instead. Headers seems not enough.
    - Add kernel-headers to build requires
    - Switch to tmpfiles for [/var]/run dirs

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jan 09 2013 cjw <cjw> 1.0.1-3.mga3
+ Revision: 343403
- patch3: fix path substitution in virtlockd.service

* Wed Jan 02 2013 pterjan <pterjan> 1.0.1-2.mga3
+ Revision: 337481
- Fix for _libdir != _libexecdir

* Tue Dec 18 2012 fwang <fwang> 1.0.1-1.mga3
+ Revision: 332243
- update file list
- new version 1.0.1

* Thu Nov 22 2012 blino <blino> 1.0.0-2.mga3
+ Revision: 320995
- require ebtables for libvirtd

* Mon Nov 05 2012 fwang <fwang> 1.0.0-1.mga3
+ Revision: 314304
- new version 1.0.0

* Wed Sep 26 2012 fwang <fwang> 0.10.2-1.mga3
+ Revision: 297893
- new version 0.10.2
- drop unused patch

* Sat Sep 01 2012 fwang <fwang> 0.10.1-1.mga3
+ Revision: 286791
- new version 0.10.1

* Tue Aug 14 2012 guillomovitch <guillomovitch> 0.9.13-3.mga3
+ Revision: 281317
- drop sysinit support

* Fri Aug 03 2012 fwang <fwang> 0.9.13-2.mga3
+ Revision: 278265
- more dir fix
- fix systemd unit dir
- rebuild for new parted

* Sat Jul 14 2012 tv <tv> 0.9.13-1.mga3
+ Revision: 270667
- adjust file list
- rediff patch 1
- new release

* Sat Jun 30 2012 colin <colin> 0.9.12-2.mga3
+ Revision: 265337
- Hopefully fix build against libnl3
- Rebuild against new libudev major

  + ovitters <ovitters>
    - drop patch 1\n-new version 0.9.12

* Mon May 28 2012 blino <blino> 0.9.10-6.mga3
+ Revision: 248291
- call post/preun scripts for libvirtd and libvirt-guests services

* Sat Apr 28 2012 tmb <tmb> 0.9.10-5.mga2
+ Revision: 233764
- Require rpm-helper >= 0.24.8-1 for systemd support

* Wed Apr 18 2012 guillomovitch <guillomovitch> 0.9.10-4.mga2
+ Revision: 231331
- systemd support

* Tue Mar 20 2012 tmb <tmb> 0.9.10-3.mga2
+ Revision: 225055
- build against libnl3 (ubuntu, P1)

* Sun Mar 04 2012 misc <misc> 0.9.10-2.mga2
+ Revision: 217731
- add libyajl-devel as BuildRequires, should fix #4685

* Wed Feb 22 2012 ovitters <ovitters> 0.9.10-1.mga2
+ Revision: 212356
- clean spec
- update file list
- new version

* Tue Jan 10 2012 fwang <fwang> 0.9.9-1.mga2
+ Revision: 194440
- new version 0.9.9

* Tue Dec 20 2011 wally <wally> 0.9.8-1.mga2
+ Revision: 184995
- new version 0.9.8

* Tue Dec 06 2011 tv <tv> 0.9.7-1.mga2
+ Revision: 177975
- fix file list
- fix file list
- new release

* Thu Sep 22 2011 fwang <fwang> 0.9.6-1.mga2
+ Revision: 146723
- new version 0.9.6

* Tue Sep 20 2011 fwang <fwang> 0.9.5-1.mga2
+ Revision: 146121
- update file list
- new version 0.9.5
- add provides for libvirt-client
- new version 0.9.4
- add default-stop section
- rebuild for new gnutls

* Tue Jul 19 2011 fwang <fwang> 0.9.3-2.mga2
+ Revision: 126189
- rebuild for new parted

* Tue Jul 05 2011 fwang <fwang> 0.9.3-1.mga2
+ Revision: 118648
- new version 0.9.3

* Tue Jun 21 2011 saispo <saispo> 0.9.2-1.mga2
+ Revision: 111211
- fix typo
- Comment one file
- Update to 0.9.2

* Mon Apr 18 2011 misc <misc> 0.9.0-1.mga1
+ Revision: 87639
- update to 0.9, synced from Mandriva and guillaume rousse work
- drop patch 0, merged upstream
- add BuildRequires on systemtap and pcap-devel

* Tue Apr 05 2011 misc <misc> 0.8.8-3.mga1
+ Revision: 80706
- rebuild
- add patch from upstream, synced from Mandriva
- build with netcf
- use udev rather than hal, change synced from Matthew Dawkins and Mandriva

* Thu Mar 24 2011 boklm <boklm> 0.8.8-2.mga1
+ Revision: 76183
- rebuild for bug #497

* Mon Mar 07 2011 saispo <saispo> 0.8.8-1.mga1
+ Revision: 65995
- New release 0.8.8

  + misc <misc>
    - add missing Requires ( without iptables, the network do not work )

  + tmb <tmb>
    - imported package libvirt

